package xyz.lychee.lagfixer.nms.v1_20_R2;

import net.minecraft.world.entity.vehicle.EntityBoat;
import net.minecraft.world.entity.vehicle.EntityMinecartAbstract;
import net.minecraft.world.entity.vehicle.EntityMinecartContainer;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.craftbukkit.v1_20_R2.entity.CraftBoat;
import org.bukkit.craftbukkit.v1_20_R2.entity.CraftMinecart;
import org.bukkit.craftbukkit.v1_20_R2.entity.CraftMinecartChest;
import org.bukkit.craftbukkit.v1_20_R2.entity.CraftVehicle;
import org.bukkit.entity.Entity;
import xyz.lychee.lagfixer.modules.CustomVehiclesModule;

public class CustomVehicles extends CustomVehiclesModule.NMS {
   private final boolean minecart_remove_chest;
   private final boolean minecart_collides;
   private final boolean minecart_silent;
   private final boolean minecart_culling;
   private final boolean minecart_physics;
   private final boolean boat_collides;
   private final boolean boat_silent;
   private final boolean boat_culling;
   private final boolean boat_physics;
   private final double minecart_maxspeed;
   private final double boat_maxspeed;

   public CustomVehicles(CustomVehiclesModule module) {
      super(module);
      ConfigurationSection section = this.getModule().getSection();
      this.minecart_remove_chest = section.getBoolean("boat.remove_chest");
      this.minecart_silent = section.getBoolean("minecart.silent");
      this.minecart_culling = section.getBoolean("minecart.culling");
      this.minecart_physics = section.getBoolean("minecart.physics");
      this.minecart_maxspeed = section.getDouble("minecart.max_speed");
      this.minecart_collides = section.getBoolean("minecart.collides");
      this.boat_silent = section.getBoolean("boat.silent");
      this.boat_culling = section.getBoolean("boat.culling");
      this.boat_physics = section.getBoolean("boat.physics");
      this.boat_maxspeed = section.getDouble("boat.max_speed");
      this.boat_collides = section.getBoolean("boat.collides");
   }

   public boolean isDefaultVehicle(Entity ent) {
      return ent instanceof CraftVehicle && !((CraftVehicle)ent).getHandle().ai().contains("LagFixer");
   }

   public void setCustomVehicle(Entity ent) {
      if (this.minecart_remove_chest && ent instanceof CraftMinecartChest) {
         EntityMinecartContainer mc = ((CraftMinecartChest)ent).getHandle();
         mc.a();
         mc.bB();
      } else {
         if (this.isDefaultVehicle(ent)) {
            if (ent instanceof CraftBoat) {
               EntityBoat boat = ((CraftBoat)ent).getHandle();
               boat.P = this.boat_collides;
               boat.Q = this.boat_collides;
               boat.S = this.boat_collides;
               boat.R = this.boat_collides;
               boat.d(this.boat_silent);
               boat.af = !this.boat_physics;
               boat.at = !this.boat_culling;
               boat.maxSpeed = this.boat_maxspeed / 20.0;
               boat.a("LagFixer");
            } else if (ent instanceof CraftMinecart) {
               EntityMinecartAbstract mc = ((CraftMinecart)ent).getHandle();
               mc.P = this.minecart_collides;
               mc.Q = this.minecart_collides;
               mc.S = this.minecart_collides;
               mc.R = this.minecart_collides;
               mc.d(this.minecart_silent);
               mc.af = !this.minecart_physics;
               mc.at = !this.minecart_culling;
               mc.maxSpeed = this.minecart_maxspeed / 20.0;
               mc.a("LagFixer");
            }
         }

      }
   }
}
